package example_comparable_box;

import java.util.ArrayList;
import java.util.Collections;

public class Box implements Comparable<Box> {
	double length, width, height, volume;
	
	public Box( double l, double w, double h ) {
	   this.length=l;
	   this.width=w;
	   this.height=h;
	   this.volume = l*w*h;
	}
   
	@Override
	public boolean equals(Object o) {
		if(o instanceof Box) {
			return this.getVolume() == ((Box)o).getVolume();
		}
		return false;
	}

	public double getVolume() { return volume; }

	@Override
	public int compareTo( Box otherBox ) {
		double diff = this.volume - otherBox.volume;
		if(diff < 0) {
			return -1;
		}
		else if(diff > 0) {
			return 1;
		}
		else {
			return 0;
		}
	}

//	public int compareTo2( Box otherBox ) {
//		return this.volume - otherBox.volume;
//	}

	@Override
	public String toString() {
		return "Box: vol=" + volume;
	}

	public static void main( String[] args) {
		ArrayList<Box> boxes = new ArrayList<>();
		boxes.add(new Box(3,5,2));
		boxes.add(new Box(2,2,2));
		boxes.add(new Box(2,2,4));
		
		System.out.println("Before Sort:");
		for( Box b : boxes )
			System.out.println( b );
		
		Collections.sort(boxes);
		
		System.out.println("\nAfter Sort:");
		for( Box b : boxes )
			System.out.println( b );
	}
   
}

