package example_comparable_box;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;

public class BoxTest {

	public static void main(String[] args) {
		testCompareTo_Equal_Sorted();
		testCompareTo_LessThan_Sorted();
		testCompareTo_GreaterThan_Sorted();
		testEquals_True();
		testEquals_False();
	}

	private static void testCompareTo_Equal_Sorted() {
		System.out.println("-->testCompareTo_Equal_Sorted()");
		Box b1 = new Box(2.0, 5.0, 3.0);
		Box b2 = new Box(5.0, 3.0, 2.0);
		ArrayList<Box> boxes = new ArrayList<>(Arrays.asList(b1, b2));
		Collections.sort(boxes);
		
		
		System.out.println(String.format("Box 1 volume = %.2f\nBox 2 volume = %.2f",
                b1.getVolume(), b2.getVolume()));
		System.out.println("Box 1 and Box 2 have the same volume:\n");
		System.out.println("Expected: [Box: vol=30.0, Box: vol=30.0]");
		System.out.println("  Actual: " + boxes);
	}
	
	private static void testCompareTo_LessThan_Sorted() {
		System.out.println("\n-->testCompareTo_LessThan_Sorted()");
		Box b1 = new Box(2.0, 5.0, 3.0);
		Box b2 = new Box(5.0, 7.0, 2.0);
		ArrayList<Box> boxes = new ArrayList<>(Arrays.asList(b1, b2));
		Collections.sort(boxes);
		
		System.out.println(String.format("Box 1 volume = %.2f\nBox 2 volume = %.2f",
                b1.getVolume(), b2.getVolume()));
		System.out.println("Box 1 has lesser volume than Box 2:\n");
		System.out.println("Expected: [Box: vol=30.0, Box: vol=70.0]");
		System.out.println("  Actual: " + boxes);
	}
	
	private static void testCompareTo_GreaterThan_Sorted() {
		System.out.println("\n-->testCompareTo_GreaterThan_Sorted()");
		Box b1 = new Box(2.0, 5.0, 3.0);
		Box b2 = new Box(5.0, 2.0, 2.0);
		ArrayList<Box> boxes = new ArrayList<>(Arrays.asList(b1, b2));
		Collections.sort(boxes);
		
		System.out.println(String.format("Box 1 volume = %.2f\nBox 2 volume = %.2f",
                b1.getVolume(), b2.getVolume()));
		System.out.println("Box 1 has greater volume than Box 2:\n");
		System.out.println("Expected: [Box: vol=20.0, Box: vol=30.0]");
		System.out.println("  Actual: " + boxes);
	}
	
	private static void testEquals_True() {
		System.out.println("\n-->testEquals_True()");
		Box b1 = new Box(2.0, 5.0, 3.0);
		Box b2 = new Box(5.0, 3.0, 2.0);
		
		System.out.println(String.format("Box 1 volume = %.2f\nBox 2 volume = %.2f",
                b1.getVolume(), b2.getVolume()));
		
		boolean equals = b1.equals(b2);
		System.out.println("Expected: b1 is equal to b2? = true");
		System.out.println("  Actual: b1 is equal to b2? = " + equals);
	}
	
	private static void testEquals_False() {
		System.out.println("\n-->testEquals_False()");
		Box b1 = new Box(2.0, 5.0, 3.0);
		Box b2 = new Box(5.0, 7.0, 2.0);
		
		System.out.println(String.format("Box 1 volume = %.2f\nBox 2 volume = %.2f",
				                          b1.getVolume(), b2.getVolume()));
		
		boolean equals = b1.equals(b2);
		System.out.println("Expected: b1 is equal to b2? = false");
		System.out.println("  Actual: b1 is equal to b2? = " + equals);
	}
}
