package example_comparable_person_lastname;

/**
 * Compares on last name only.
 * @author dgibson
 *
 */
public class Person implements Comparable<Person> {
	private String lastName;
	private String firstName;

	public Person(String lastName, String firstName) {
		this.lastName = lastName;
		this.firstName = firstName;
	}

	public String getLastName() { return lastName; }

	public String getFirstName() { return firstName; }

	public int compareTo( Person other ) {
		return this.lastName.compareTo(other.lastName);
	}
	
	public boolean equals(Object o) {
		if(o instanceof Person) {
			Person other = (Person)o;
			return this.lastName.equals(other.lastName);
		}
		return false;
	}

	public String toString()
	{
		return lastName + ", " + firstName;
	}
}

