package example_comparable_person_lastname;

import java.util.*;

public class PersonTest
{
	public static void main(String[] args)
	{
		test1();
		test2();
	}

	public static void test1()
	{
		Person p1 = new Person( "Wilson", "Henry" );
		Person p2 = new Person( "Jones", "Sherry" );
		Person p3 = new Person( "Jones", "Aron" );
		Person p4 = new Person( "Jones", "Aron" );

		System.out.println( p1.compareTo(p2) ); // positive
		System.out.println( p2.compareTo(p3) ); // positive
		System.out.println( p2.compareTo(p1) ); // negative
		System.out.println( p3.compareTo(p4) ); // zero
	}

	public static void test2()
	{
		Person p1 = new Person( "Wilson", "Henry" );
		Person p2 = new Person( "Jones", "Sherry" );
		Person p3 = new Person( "Jones", "Aron" );
		Person p4 = new Person( "Purns", "Nivel" );

		Person[] persons = {p1,p2,p3,p4};

		Arrays.sort( persons );

		System.out.println( Arrays.toString( persons ) );


		// Or use an array list
 		ArrayList<Person> persons2 = new ArrayList<Person>();

 		persons2.add(p1); persons2.add(p2); persons2.add(p3); persons2.add(p4);

 		Collections.sort( persons2 );

 		for( Person p : persons2 ) System.out.println( p );

 		testMethodsThatRelyOnComparable();
	}

	public static void testMethodsThatRelyOnComparable() {
		System.out.println( "\ntestMethodsThatRelyOnComparable()" );

		Person p1 = new Person( "Wilson", "Henry" );
		Person p2 = new Person( "Purns", "Nivel" );
		Person p3 = new Person( "Jones", "Sherry" );
		Person p4 = new Person( "Jones", "Aron" );
		Person p5 = new Person( "Purns", "Nivel" );

		ArrayList<Person> persons = new ArrayList<Person>();
		persons.add(p1); persons.add(p2); persons.add(p3); persons.add(p4); persons.add(p5);

		System.out.println("Collections.max(persons):" + Collections.max(persons));
		System.out.println("Collections.min(persons):" + Collections.min(persons));
		System.out.println("persons.contains(p3)    :" + persons.contains(p3));
		System.out.println("persons.indexOf(p2)     :" + persons.indexOf(p2));
		System.out.println("persons.lastIndexOf(p2) :" + persons.lastIndexOf(p2));
		System.out.println("persons.remove(p1)      :" + persons.remove(p1));


 		//Collections.sort(persons);

	}

	public static void printAlphabetical( Person p1, Person p2 )
	{
		if( p1.compareTo(p2) <= 0 )
			System.out.println( p1 + "\n" + p2 + "\n" );
		else if( p1.compareTo(p2) > 0 )
			System.out.println( p2 + "\n" + p1 + "\n" );
	}
}

