package example_person_animals_ver1;

import java.util.ArrayList;

public class Person {
	private String name;
	private ArrayList<Animal> pets = new ArrayList<>();

	public Person(String name) {
		this.name = name;
	}

	public boolean addPet(Animal a) {
		if(!pets.contains(a)) {
			pets.add(a);
			return true;
		}
		return false;
	}

	public ArrayList<Dog> getDogs() {
		ArrayList<Dog> dogs = new ArrayList<>();
		for(Animal a : pets) {
			if(a instanceof Dog) {
				dogs.add((Dog)a);
			}
		}
		return dogs;
	}

	public String getName() {
		return name;
	}

	public int getNumPets() {
		return pets.size();
	}
	
	public Animal getPet(int i) {
		if( i>=0 && i<pets.size()) {
			return pets.get(i);
		}
		return null;
	}
	
	public Animal getPet(String name) {
		Animal a = new Dog(name);
		// or...
		// Animal a = new Bird(name);
		if(pets.contains(a)) {
			int loc = pets.indexOf(a);
			return pets.get(loc);
		}
		return null;
	}
	
	public String makeSounds() {
		String msg = "";
		for(Animal a : pets) {
			msg += a.makeSound() + " ";
		}
		return msg;
	}
	
	public Animal removePet(int i) {
		if( i>=0 && i<pets.size()) {
			return pets.remove(i);
		}
		return null;
	}
	
	public Animal removePet(String name) {
		Animal a = new Dog(name);
		if(pets.contains(a)) {
			int loc = pets.indexOf(a);
			return pets.remove(loc);
		}
		return null;
	}
	
	@Override
	public String toString() {
		String msg = name + "'s pets:\n";
		for(Animal a : pets) {
			msg += a + "\n";
		}
		return msg;
	}
}
