package example_person_clone_shallow;

import java.util.ArrayList;
import java.util.Arrays;

// Shallow copy, arraylist not cloned properly
public class Person2 implements Cloneable {

	private String name;
	private ArrayList<Integer> scores;
	
	public Person2( String name, ArrayList<Integer> scores ) {
		this.name = name;
		this.scores = scores;
	}
	
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public int getScore( int i ) { 
		return scores.get(i); 
	}
	
	public void addScore( int score ) { 
		scores.add(score); 
	}

	public void setScore( int i, int score ) { 
		scores.set(i, score); 
	}
	
	public int getNumScores() {
		return scores.size();
	}
	
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
	
	public String toString() {
		String msg = ", Scores: ";
		for( int score : scores )
			msg += score + ", ";
		return "Name: " + name + msg;
	}
	
	public static void main(String[] args) throws CloneNotSupportedException {
		
		ArrayList<Integer> scores = new ArrayList<>( 
				Arrays.asList(85, 72, 96));

		Person2 p1 = new Person2( "Alex", scores );
		Person2 p2 = (Person2)p1.clone();	
		System.out.println( "After Clone" );
		System.out.println( p1 + "\n" + p2 );
		System.out.println( "Change Age and First Score in Clone" );
		p2.setName("Zeke");
		p2.setScore(0, 55);
		System.out.println( p1 + "\n" + p2 );
	}
		
}
