package example_person_dogs_clone_deep;
import java.util.*;

public class Person implements Cloneable {
	private String name;
	private ArrayList<Dog> dogs = new ArrayList<>();
	
	public Person(String name) {
		this.name = name;
	}

	public Object clone() throws CloneNotSupportedException {
		// Clone the person
		Person clone = (Person)super.clone();
		// Clone the list of dogs
		ArrayList<Dog> cDogs = new ArrayList<>();
		// Clone each dog and added to the new list
		for(Dog d : dogs) {
			cDogs.add((Dog)d.clone());
		}
		// Assign the new list of dogs to the clone list
		clone.dogs = cDogs;
		return clone;
	}
	
//	public Object clone() throws CloneNotSupportedException {
//		// Clone the person
//		Person clone = (Person)super.clone();
//		
//		// Clone the list of dogs
//		ArrayList<Dog> cDogs = (ArrayList<Dog>)dogs.clone();
//		
//		// Clear the cloned list of dogs
//		cDogs.clear();
//		
//		// Clone each dog and added to the clone list
//		for(Dog d : dogs) {
//			cDogs.add((Dog)d.clone());
//		}
//	
//		// Assign the clone's dogs to the clone list
//		clone.dogs = cDogs;
//		
//		return clone;
//	}
	
//	public Dog getDog( int i ) { return dogs[i]; }
	public void addDog(Dog dog) { dogs.add(dog); }
	
	public String toString() {
		String msg = "Name: " + name + ", Dogs:";
		for( Dog d : dogs ) msg += d + ", ";
		return msg;
	}
	
	public static void main(String[] args) throws CloneNotSupportedException {
		Person p1 = new Person("Xavier");
		p1.addDog(new Dog("Spot"));
		p1.addDog(new Dog("Leo"));
		
 		Person p2 = (Person)p1.clone();	
 		System.out.println( "After clone: person 1=" + p1 + ", Person 2=" + p2 );

		Dog d = p2.dogs.get(0);
		d.setName("Waldo");
		p2.addDog(new Dog("Chaps"));
 		System.out.println( "After change of clone: person 1=" + p1 + ", Person 2=" + p2 );
	}
	
}

