package exercise_blobs;

public abstract class Blob implements Comparable<Blob> {
	protected int id;
	protected double tenacity;

	public Blob(int id, double tenacity) {
		this.id = id;
		this.tenacity = tenacity;
	}

	public int getId() {
		return id;
	}

	public double getTenacity() {
		return tenacity;
	}

	public abstract void constrict();

	@Override
	public int compareTo(Blob otherBlob) {
		int idDiff = this.id - otherBlob.id;
		if(idDiff != 0)
			return idDiff;
		else {
			double tenacityDiff = this.tenacity - otherBlob.tenacity;
			if(tenacityDiff < 0)
				return -1;
			else if(tenacityDiff > 0)
				return 1;
			else
				return 0;
		}
	}

	@Override
	public boolean equals(Object o) {
		Blob otherBlob = (Blob)o;

		return this.id==otherBlob.id && this.tenacity == otherBlob.tenacity;

	}
}

