package exercise_books;

public class Book implements Comparable<Book> {
	private String title;

	public Book(String title) {
		this.title = title;
	}
	public String getTitle() {
		return title;
	}
	@Override
	public int compareTo(Book otherBook) {
		String thisBookTitle = getEffectiveTitle(this.title);
		String otherBookTitle = getEffectiveTitle(otherBook.title);
		return thisBookTitle.compareTo(otherBookTitle);
	}
	@Override
	public boolean equals(Object o) {
		String thisBookTitle = getEffectiveTitle(this.title);
		String otherBookTitle = getEffectiveTitle(((Book)o).title);
		return thisBookTitle.equals(otherBookTitle);
	}

	// Helper method to remove "The" from title if it exists
	private String getEffectiveTitle(String t) {
		if(t.substring(0, 3).equals("The"))
			return t.substring(4);
		return t;
	}
	@Override
	public String toString() {
		return title;
	}
}
