package exercise_drawing_shapes;

public class Circle extends Shape {
	private double radius;

	public Circle(String color, double radius) {
		super(color);
		this.radius = radius;
	}

	public double getRadius() {
		return radius;
	}

	public void setRadius(double radius) {
		this.radius = radius;
	}

	@Override
	public double getArea() {
		return Math.PI*Math.pow(radius, 2.0);
	}

	@Override
	public double getPerimeter() {
		return 2*Math.PI*radius;
	}

	@Override
	public String toString() {
		String msg = String.format("Circle [radius=%.2f, getArea()=%.2f, getPerimeter()=%.2f, getColor()=%s]",
				radius, getArea(), getPerimeter(), getColor());
		return msg;
	}
}
