package exercise_drawing_shapes;

public class CircleTest {

	public static void main(String[] args) {
		testCreate();
		testGetArea();
		testGetPerimeter();
		testToString();
	}
	
	private static void testCreate() {
		System.out.println("-->testCreate()");
		Circle c = new Circle("Blue", 1.5);
		System.out.println("Expected: " + 
		"Circle [radius=1.50, getArea()=7.07, getPerimeter()=9.42, getColor()=Blue]");
		
		System.out.println("  Actual: " + c);
	}
	
	private static void testGetArea() {
		System.out.println("\n-->testGetArea()");
		Circle c = new Circle("Red", 2.0);
		double area = c.getArea();
		
		System.out.println("Expected Red circle's area = 12.57");
		System.out.println(String.format("  Actual Red circle's area = %.2f", area));
	}
	
	private static void testGetPerimeter() {
		System.out.println("\n-->testGetPerimeter()");
		Circle c = new Circle("Green", 3.5);
		double perimeter = c.getPerimeter();
		
		System.out.println("Expected Green circle's perimeter = 21.99");
		System.out.println(String.format("  Actual Green circle's perimeter = %.2f", perimeter));		
	}
	
	private static void testToString() {
		System.out.println("\n--testToString()");
		Circle c1 = new Circle("Red", 2.0);
		Circle c2 = new Circle("Green", 3.5);
		Circle[] circles = {c1, c2};
		
		for(Circle c : circles) {
			System.out.println(c.toString());
		}
	}
}
