package exercise_drawing_shapes;

import java.util.ArrayList;
import java.util.List;

public class Drawing {
	private List<Shape> shapes = new ArrayList<>();
	
	public Drawing() {}
	
	public void addShape(Shape shape) {
		shapes.add(shape);
	}
	
	public Shape getShape(int i) {
		if(i<0 || i>=shapes.size()) {
			return null;
		}
		return shapes.get(i);
	}

	public Shape removeShape(int i) {
		if(i<0 || i>=shapes.size()) {
			return null;
		}
		return shapes.remove(i);
	}

	public List<Shape> getBigShapes(double area) {
		List<Shape> bigShapes = new ArrayList<>();
		for(Shape shape : shapes) {
			if(shape.getArea() > area) {
				bigShapes.add(shape);
			}
		}
		return bigShapes;
	}
	
	public String getRectangleDimensions() {
		StringBuilder sb = new StringBuilder();
		for(Shape shape : shapes) {
			if(shape instanceof Rectangle) {
				Rectangle rect = (Rectangle)shape;
//				sb.append(String.format("[length = %.2f, width = %.2f]\n",rect.getLength(), rect.getWidth()));
				sb.append(String.format("%.1f %.1f ",rect.getLength(), rect.getWidth()));			}
		}
		return sb.toString();
	}
	
}
