package exercise_drawing_shapes;

public class RectangleTest {

	public static void main(String[] args) {
		testCreate();
		testGetArea();
		testGetPerimeter();
		testToString();
	}

	private static void testCreate() {
		System.out.println("-->testCreate()");
		Rectangle r = new Rectangle("Blue", 2.0, 1.5);
		System.out.println("Expected: " + 
		"Rectangle [length=2.00, width=1.50, getArea()=3.00, getPerimeter()=7.00, getColor()=Blue]");
		
		System.out.println("  Actual: " + r);
	}
	
	private static void testGetArea() {
		System.out.println("\n-->testGetArea()");
		Rectangle r = new Rectangle("Red", 7.0, 5.5);
		double area = r.getArea();
		
		System.out.println("Expected Red rectangle's area = 38.50");
		System.out.println(String.format("  Actual Red rectangle's area = %.2f", area));
	}
	
	private static void testGetPerimeter() {
		System.out.println("\n-->testGetPerimeter()");
		Rectangle r = new Rectangle("Green", 5.0, 14.2);
		double perimeter = r.getPerimeter();
		
		System.out.println("Expected Green rectangle's perimeter = 38.40");
		System.out.println(String.format("  Actual Green rectangle's perimeter = %.2f", perimeter));		
	}
	
	private static void testToString() {
		System.out.println("\n--testToString()");
		Rectangle r1 = new Rectangle("Green", 5.0, 14.2);
		Rectangle r2 = new Rectangle("Red", 7.0, 5.5);
		Rectangle[] rectangles = {r1, r2};
		
		for(Rectangle r : rectangles) {
			System.out.println(r.toString());
		}
	}
}
