package exercise_grade_report;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;

class GradeReportDropLowest extends GradeReport {
	int numToDrop;
	public GradeReportDropLowest(String name, ArrayList<Double> scores, int numToDrop) {
		super(name, scores);
		this.numToDrop = numToDrop;
	}

	@Override
	public double calcAverage() {
		ArrayList<Double> scores2 = (ArrayList<Double>)scores.clone();
		removeLowScores(scores2);
		return calcAverage(scores2);
	}

	private void removeLowScores(ArrayList<Double> scores) {
		for(int i=0; i<numToDrop; i++) {
			double min = Collections.min(scores);
			scores.remove(min);
		}
	}

	private double calcAverage(ArrayList<Double> scores) {
		double sum = 0.0;
		for(double d : scores)
			sum += d;
		return sum/scores.size();
	}

	public static void main(String[] args) {
		ArrayList<Double> scores = new ArrayList<>(Arrays.asList(100.0, 50.0, 80.0, 30.0 ));
		GradeReportDropLowest gr = new GradeReportDropLowest("Dave", scores, 2);
		double average = gr.calcAverage();
		System.out.println("average=" + average);
		average = gr.calcAverage();
		System.out.println("average=" + average);
	}
}

