package exercise_grade_report;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;

class GradeReportScaled extends GradeReport {
	double scalePercent;
	public GradeReportScaled(String name, ArrayList<Double> scores, double scalePercent) {
		super(name, scores);
		this.scalePercent = scalePercent;
	}

	@Override
	public double calcAverage() {
		ArrayList<Double> scores2 = (ArrayList<Double>)scores.clone();
		scaleScores(scores2);
		return calcAverage(scores2);
	}

	private void scaleScores(ArrayList<Double> scores) {
		for(int i=0; i<scores.size(); i++) {
			scores.set(i, scores.get(i)*(1+scalePercent));
		}
	}

	private double calcAverage(ArrayList<Double> scores) {
		double sum = 0.0;
		for(double d : scores)
			sum += d;
		return sum/scores.size();
	}

	public static void main(String[] args) {
		ArrayList<Double> scores = new ArrayList<>(Arrays.asList(100.0, 50.0, 80.0, 30.0 ));
		GradeReportScaled gr = new GradeReportScaled("Dave", scores, 0.1);
		double average = gr.calcAverage();
		System.out.println("average=" + average);
		average = gr.calcAverage();
		System.out.println("average=" + average);
	}
}

